(function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _speak = require('./speak');

var _speak2 = _interopRequireDefault(_speak);

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : { default: obj };
}

/**
 * add speak to console or throw an Error
 */
var init = function init() {
  try {
    window.console.speak = new _speak2.default(window);
  } catch (err) {
    throw err;
  }
};

exports.default = init;

},{"./speak":3}],2:[function(require,module,exports){
'use strict';

var _speak = require('./speak');

var _speak2 = _interopRequireDefault(_speak);

var _console = require('./console');

var _console2 = _interopRequireDefault(_console);

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : { default: obj };
}

(0, _console2.default)();

},{"./console":1,"./speak":3}],3:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);
    }
  }return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;
  };
}();

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

/**
 * HTML5 speechSynthesis queue handler
 */
var Speak = function () {
  /**
   * create a speaker and synth instance
   * @constructor
   * @param  {Object} global window
   * @return {Function} returns the `speak method`
   */
  function Speak(global) {
    _classCallCheck(this, Speak);

    this.speaker = global.speechSynthesis;
    this.synth = new SpeechSynthesisUtterance();
    /**
     * a queue of texts to be spoken when the last
     * one has finished
     * @type {Array}
     */
    this.queue = [];
    /**
     * assign the `onEnd` method to the synths
     * `onend` listener
     * @type {Function}
     */
    this.synth.onend = this.onEnd.bind(this);
    /**
     * return the `speak` method
     */
    return this.speak.bind(this);
  }
  /**
   * handler to manage the queue when a speech has ended.
   */

  _createClass(Speak, [{
    key: 'onEnd',
    value: function onEnd() {
      // allow new speech
      this.speaking = false;
      // check for queue items
      if (this.queue[0]) {
        // items found:
        // play the next item and remove it from the queue
        var next = this.queue[0];
        this.speak(next.message, next.options);
        this.queue.splice(0, 1);
      }
    }
    /**
     * method that actually speaks.
     * This method checks if speaker is already speaking.
     * If `true` the new message and options will be added to
     * the queue, otherwise the message is spoken
     * @param  {String} message [description]
     * @param  {Object} options [description]
     * @return {[type]}         [description]
     */

  }, {
    key: 'speak',
    value: function speak() {
      var message = arguments.length <= 0 || arguments[0] === undefined ? '' : arguments[0];
      var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

      if (this.speaking) {
        this.queue.push({ message: message, options: options });
      } else {
        // define some safe options to make make sure only
        // [lang,pitch,rate,volume] can be changed and have defaults
        var safeOptions = {
          lang: options.lang || 'en-US',
          pitch: options.pitch || 1,
          rate: options.rate || 1,
          volume: options.volume || 1,
          text: message
        };
        // block next messages (force to queue)
        // apply options and speak
        this.speaking = true;
        Object.assign(this.synth, safeOptions);
        this.speaker.speak(this.synth);
      }
    }
  }]);

  return Speak;
}();

exports.default = Speak;

},{}]},{},[2]);
